package GeoDB::Display;

use strict;
use GeoDB;

our @ISA = qw(GeoDB);

our $VERSION = "0.71";

1;

=cut

=head1 NAME

GeoDB::Display - module structure for displaying data from a GeoDB search set.

=head1 SYNOPSIS

This module is merely a parent class for real display modules.

=head1 DESCRIPTION

START HELP

The Display modules show the results to your screen in some fashion.
Many times they will manipulate date in some interesting way before
displaying it to you.  The list of display modules distributed with
GeoQO are:

=for comment
START LIST

  Help
  Count
  List
  Show
  Top10
  Sets
  Stats
  Gui/list
  Gui/show
  Graph/find
  Graph/placed
  Dump

=for comment
END LIST

To see help on any of the above SUBTOPICs, run:

  > geoqo -d help:topic=display/SUBTOPIC

END HELP
