package GeoDB::Display::Count;

use strict;
use GeoDB::Display;
use GeoDB::Utils;

our @ISA = qw(GeoDB::Display);

our $VERSION = "0.71";

our @GEOOPTIONS=
  ({name => 'prefix',
    help => 'The prefix string to print right before the count',
    default => "Search/Set Count: "
   });

sub display {
    my ($self, $set, $dbh) = @_;

    GEODEBUG(3, "Displaying Set Count\n");
    return $self->{'options'}{'prefix'} . $set->num() . "\n";
}


1;
=head1 NAME

Count - Count the results in the search set

=head1 DESCRIPTION

START HELP

  Example:
  geoqo -s 'set:import:my pocket query' -d count
  Search/Set Count: 500

The Count display simply counts the results in a set.  This is very
useful for counting the results before you do something with them
(like dumping 500 caches to your screen when you were looking for just
a few).

END HELP

=cut

