package GeoDB::Display::Graph;

use strict;
use GeoDB::Display;
use GeoDB::Utils;

my $have_qw = eval "require QWizard";

our @ISA = qw(GeoDB::Display);

our $VERSION = "0.71";

sub get_graph_data {
    GEOERR("illegal graph invocation\n");
}

sub get_graph_options {
    return [];
}

sub display {
    my ($self, $set, $dbh) = @_;

    GEOERR("can't display graphs: QWizard perl module not installed")
      if (!$have_qw);
    my ($data, $title, $ylabel) = $self->get_graph_data($set, $dbh);
    my $options = $self->get_graph_options();
    my $qw = 
      new QWizard(primaries => 
		  {'disp' =>
		   {title => $title,
		    questions => [{
				   type => 'graph',
				   multidata => 1,
				   values => [[$data]],
				   graph_options => [-width => 600,
						     -height => 600,
						     'bgclr', '#ffffff',
						     'transparent', 0,
						     @$options],
				  }]
		   }}
		 );
    $qw->magic('disp');
}


1;
