package GeoDB::Display::Gui::List::Plugin::Show;

use strict;

use GeoDB::Display::Gui::List::Plugin;
use GeoDB::Utils;
use QWizard;
use GeoDB::Set;

our @ISA = qw(Display::Gui::List::Plugin);

use strict;

our $VERSION = "0.71";

sub get_early_headers {
    return 'Show';
}

sub get_early_columns {
    my ($self, $cache, $num) = @_;
    return
      { type => 'button',
	name => 'showit',
	default => $num,
	values => 'Show',
      };
}

sub post_answers {
    if (qwparam('showit') ne '') {

	my $self = $_[$#_];
	my $set = $_[$#_ - 1];
	my $cache = $set->get(qwparam('showit'));

	$cache->load({nologs => 1, noattributes => 1});
	if ($self->get_option('showinweb') &&
	    $cache->{'data'}{'type'} eq 'Geocache') {
	    my $browser = $self->get_option('webbrowser') || "firefox";
	    my $id = $cache->{'data'}{'ident'};
	    system("$browser \"http://www.geocaching.com/seek/cache_details.aspx?wp=${id}&Submit6=Go\" &");
	} else {
	    my $nset = new GeoDB::Set;
	    $nset->add($cache);

	    # XXX: can we work around this in a cleaner way?
	    my $master = $self->get_master();
	    my $qw = $master->{'qwizard'};
	    delete $master->{'qwizard'};
	    $master->display($nset, "gui/show",
			     $master->{'dbh'});
	    delete $master->{'qwizard'};
	    $master->{'qwizard'} = $qw;
	    qwparam('showit', 0);
	}
	return 'REDISPLAY';
    }
}

1;
