package GeoDB::Export;

use strict;

use GeoDB;

our @ISA = qw(GeoDB);

our $VERSION = "0.71";

# XML specific and probably shouldn't go exactly here...
# stolen from XML::Smart::Entity under copyright of free / perl itself
sub _add_basic_entity {
    return if (!$_[0]);
    my $x = shift;
#    $x =~ s/(&(?:\w+;)?)/{_is_amp($1) or $1}/sgex ;
    $x =~ s/&/&amp;/gs ;
    $x =~ s/</&lt;/gs ;
    $x =~ s/>/&gt;/gs ;
    return( $x ) ;
}

# stolen from XML::Smart::Entity under copyright of free / perl itself
sub _is_amp {
  if ($_[0] eq '&') { return( '&amp;' ) ;}
  return( undef ) ;
}

1;

=head1 NAME

Export - export caches from a GeoDB Set

=head1 DESCRIPTION

BEGIN HELP

The exporting features within geoqo let you export your waypoints in
your search set to various different types of output formats.  See
the documentation for the sub-modules for futher details.

The list of search modules distributed with GeoQO are:

=for comment
START LIST

  Gpx
  Loc
  Kml
  System
  Html

=for comment
END LIST

To see help on any of the above SUBTOPICs, run:

  > geoqo -d help:topic=export/SUBTOPIC

END HELP

=cut
