package GeoDB::Export::Loc;

use strict;
use GeoDB::Export;
use GeoDB::Utils;

our $VERSION = "0.71";

our @ISA = qw(GeoDB::Export);

sub _x {
    return GeoDB::Export::_add_basic_entity(@_);
}

sub export_it {
    my ($self, $file, $set) = @_;

    GEODEBUG(1,"writing file: $file\n");
    open(O, ">$file");

    # XXX: use internal calc
    my $datestamp = `date +%04Y-%02m-%02dT%02H:%02M:%02S.00000000-07:00`;
    chomp($datestamp);

    # start the header
    # <bounds minlat="38.236517" minlon="-122.04275" maxlat="38.870533" maxlon="-121.271167" />
    print O "<?xml version=\"1.0\" encoding=\"utf-8\"?>
<loc version=\"1.0\" src=\"GeoQO\">
";

    $set->load({nologs => 1, noattributes => 1});
    $set->foreach(sub {
		      my $c=$_[0]{'data'};
		      my $type = _x($c->{'sym'} || $c->{'type'});
		      print O "  <waypoint>
    <name id=\"" . _x($_[0]->ident()) . "\">" . _x($c->{desc}) . "</name>
    <coord lat=\"" . _x($c->{'lat'}) . "\" lon=\"" . _x($c->{'lon'}) . "\" />
    <type>$type</type>
    <link text=\"Cache Details\">" . _x($c->{url}) . "</link>
  </waypoint>
";
		  });
    print O "</loc>\n";
}

1;

=cut

=head1 NAME

Loc - export loc files

=head1 DESCRIPTION

START HELP

  > geoqo -s 'cache:name=cool cache' -e myfile.loc

The loc exporter writes out a loc file containing all the caches in
the search set.

END HELP

=head1 AUTHOR

Wes Hardaker (AKA Yamar) <hardaker ATAT users.sourceforge.net> 

=cut
