# ==============================================================================
# Alfandega::Addons::check_probe.pm
# ------------------------------------------------------------------------------
# Copyright(c) 2002 Christian Tosta <c_tosta@yahoo.com.br>. All rights reserved.
# This program is free software; you can redistribute it and/or modify it under
# the same terms as Perl itself.
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
#
#                         Alfandega Check Probe Add-On
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

package Alfandega::Addons::CheckProbe;

require 5.004;
require Exporter;

use strict;
use vars qw(@ISA $VERSION);

$VERSION = "1.3";
@ISA     = qw(Exporter);


sub new {

    shift;
    my $file = shift;
    my $table = shift;
    my %rules;
    my @rulesarray;
    my %scan;
    my %str;
    my $rule1;
    my $rule2;
    my $dump;
    my $key;
    my $value;
    my $i;

    return if $table !~ "filter";

    open(CFG,'<',$file);
    while(<CFG>) {
        chomp;
        s/^\s*(.*?)\s*$/$1/;
        my @search = $_ if !/^#/ && !/^;/;

        foreach my $line (@search) {
            $i = defined $i ? $i : 0;
            next if !$line;
            ++$i && next if $line =~ "}";
            next if $line =~ "scan {";
            ($key,$value) = split(/:/,$line,2);
            for ($key) { s/^\s*(.*?)\s*$/$1/; }
            for ($value) { s/^\s*(.*?)\s*$/$1/; }
            $scan{'scan'.$i}{$key} = $value;
        }
    }

    $str{'protocol'} = "\" -p \$val -m \$val\"";
    $str{'flags'} = "\" --tcp-flags \\\"\" . uc(\$val) . ";
    $str{'flags'} .= "\"\\\" \\\"\" . uc(\$val) . \"\\\"\"";
    $str{'interface'} = "\" -i \$val\"";
    $str{'multiport'} = "\" -m multiport --dports \$val\"";
    $str{'ports'} = "\" --dport \$val\"";
    $str{'action'} = "\"\$val\"";
    $str{'name'} = "\" --log-level \\<default_log_level>";
    $str{'name'} .= " --log-prefix \\\"\" . uc(\$val) . \": \\\"\"";

    while (($key,$value) = each %scan) {
        $rules{'protocol'} = "";
        $rules{'flags'} = "";
        $rules{'interface'} = "";
        $rules{'multiport'} = "";
        $rules{'ports'} = "";
        $rules{'action'} = "";
        $rules{'name'} = "";
        while (my ($var,$val) = each %{$value}) {
            $rules{$var} = eval $str{$var} if defined $var;
        }
        
        $rule1 = "-A chkProbe";
        $rule1 .= $rules{'interface'} ? $rules{'interface'} : "";
        $rule1 .= $rules{'protocol'} ? $rules{'protocol'} : "";
        $rule1 .= $rules{'flags'} ? $rules{'flags'} : "";
        $rule1 .= $rules{'ports'} ? $rules{'ports'} : "";
        $rule1 .= $rules{'multiport'} ? $rules{'multiport'} : "";
        $rule1 .= " -m limit --limit <default_limit_rate> ";
        $rule1 .= "--limit-burst <default_limit_burst> -j LOG";
        $rule1 .= $rules{'name'} ? $rules{'name'} : "";

        $rule2 = "-A chkProbe";
        $rule2 .= $rules{'interface'} ? $rules{'interface'} : "";
        $rule2 .= $rules{'protocol'} ? $rules{'protocol'} : "";
        $rule2 .= $rules{'flags'} ? $rules{'flags'} : "";
        $rule2 .= $rules{'ports'} ? $rules{'ports'} : "";
        $rule2 .= $rules{'multiport'} ? $rules{'multiport'} : "";

        if($rules{'action'}) {
            $rule2 .= " -j REJECT --reject-with tcp-reset\n" if $rules{'action'} =~ "reset";
            $rule2 .= " -j DROP\n" if $rules{'action'} =~ "deny";
        }
        push(@rulesarray,"$rule1\n$rule2");
    }
    foreach my $rule (@rulesarray) {
        $dump .= "$rule\n";
    }
    return $dump;
}

__END__
