# ==============================================================================
# Alfandega::Addons::icmp_control.pm
# ------------------------------------------------------------------------------
# Copyright(c) 2002 Christian Tosta <c_tosta@yahoo.com.br>. All rights reserved.
# This program is free software; you can redistribute it and/or modify it under
# the same terms as Perl itself.
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
#
#                        Alfandega ICMP Control Add-On
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

package Alfandega::Addons::IcmpControl;

require 5.004;
require Exporter;

use strict;
use vars qw(@ISA $VERSION);

$VERSION = "1.3";
@ISA     = qw(Exporter);


sub new {

    shift;
    my $file = shift;
    my $table = shift;
    my @rules;
    my $rule;
    my $dump;

    return if $table !~ "filter";

    open(CFG,'<',$file);
    while(<CFG>) {
        chomp;
        s/^\s*(.*?)\s*$/$1/;
        my @search = $_ if !/^#/ && !/^;/;

        foreach my $line (@search) {
            if($line) {

                my ($target,$status,$type,$rate,$burst) = split(/\s+/,$line,5);

                $rate = "rate:" unless $rate;
                $burst = "burst:" unless $burst;

                $status = substr($status,0,-6);
                $type = substr($type,5);
                $rate = substr($rate,5);
                $burst = substr($burst,6);

                $rule = "-A icmp$status -p icmp -m icmp --icmp-type $type ";

                if($target =~ "limit") {
                    $rule .= "-m limit --limit $rate ";
                    $rule .= "--limit-burst $burst -j allowed";
                }

                if($target =~ "allow")   { $rule .= "-j allowed"; }
                elsif($target =~ "deny") { $rule =~ "-j DROP";    }

                push(@rules,$rule);
            }
        }
    }
    foreach my $rule (@rules) {
        $dump .= "$rule\n";
    }
    return $dump;
}

__END__
