# ==============================================================================
# Alfandega::Addons::local_blacklist.pm
# ------------------------------------------------------------------------------
# Copyright(c) 2002 Christian Tosta <c_tosta@yahoo.com.br>. All rights reserved.
# This program is free software; you can redistribute it and/or modify it under
# the same terms as Perl itself.
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
#
#                       Alfandega Local Blacklist Add-On
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

package Alfandega::Addons::LocalBlacklist;

require 5.004;
require Exporter;

use strict;
use vars qw(@ISA $VERSION);

$VERSION = "2.0";
@ISA     = qw(Exporter);


sub new {

    shift;
    my $file = shift;
    my $table = shift;
    my @rules;
    my $rule;
    my $dump;

    return if $table !~ "filter";
    
    open(CFG,'<',$file);
    while(<CFG>) {
        chomp;
        s/^\s*(.*?)\s*$/$1/;
        my @search = $_ if !/^#/ && !/^;/;

        foreach my $line (@search) {
            if($line) {
                my @params = split(/\t/,$line,2);
                my $mac = index($line,":") <= -1 ? undef : $params[0];
                my $ip4 = index($line,":") <= -1 ? $params[0] : undef;

                $rule = "-I FORWARD -m mac --mac-source $mac -j DROP" if $mac;
                $rule = "-A blacklist -s $ip4 -j DROP" if $ip4;

                push(@rules,$rule);

            }
        }
    }
    foreach my $rule (@rules) {
        $dump .= "$rule\n";
    }
    return $dump;
}

__END__
