# ==============================================================================
# Alfandega::Addons::masquerading.pm
# ------------------------------------------------------------------------------
# Copyright(c) 2002 Christian Tosta <c_tosta@yahoo.com.br>. All rights reserved.
# This program is free software; you can redistribute it and/or modify it under
# the same terms as Perl itself.
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
#
#                        Alfandega Masquerading Add-On
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

package Alfandega::Addons::Masquerading;

require 5.004;
require Exporter;

use strict;
use vars qw(@ISA $VERSION %Config);

$VERSION = "1.3";
@ISA     = qw(Exporter);


sub new {

    shift;
    my $file = shift;
    my $table = shift;
    #my $class = shift;
    my @rules;
    my $rule;
    my $dump;
    #%Config = $class->config;

    return if $table !~ "nat";
    
    # Some situations requires Lan users enable masquerade too. Commenting in ip_dynaddr dependence.
    # return if $Config{'ip_dynaddr'} =~ "off";

    open(CFG,'<',$file);
    while(<CFG>) {
        chomp;
        s/^\s*(.*?)\s*$/$1/;
        my @search = $_ if !/^#/ && !/^;/;

        foreach my $line (@search) {
            if($line) {
                my ($target,$status,$interface) = split(/\s+/,$line,3);

                $status = substr($status,0,1);

                my $chain = "POSTROUTING" if $status =~ "o";
                $chain = "PREROUTING" if $status =~ "i";

                $rule = "-A $chain -$status $interface -j MASQUERADE";

                push(@rules,$rule);

            }
        }
    }
    foreach my $rule (@rules) {
        $dump .= "$rule\n";
    }
    return $dump;
}

__END__
