# ==============================================================================
# Alfandega::Language::Brazilian.pm
# ------------------------------------------------------------------------------
# Copyright(c) 2002 Christian Tosta <c_tosta@yahoo.com.br>. All rights reserved.
# This program is free software; you can redistribute it and/or modify it under
# the same terms as Perl itself.
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
#
#                      Netfilter Language Class: Brazilian
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

package Alfandega::Language::Brazilian;

require 5.004;
require Exporter;

use strict;
use vars qw(@ISA @EXPORT $VERSION);

@ISA = ('Exporter');
@EXPORT = qw(locale);
$VERSION = "1.3";

my %StrTable = (
    'Language'                      =>    "Brasileiro",
    'Config::not_specified'         =>    "Voc deve especificar o valor de ",
    'Config::bad_cfg_version'       =>    "Verso incorreta do arquivo de configurao",
    'Config::chdir_basedir'         =>    "Impossvel entrar no diretrio: ",
    'Config::opendir'               =>    "Impossvel acessar diretrio: ",
    'Config::acl_file'              =>    "Impossvel abrir arquivo de ACLs: ",
    'Config::bad_acl_version'       =>    "Verso invlida do arquivo de ACLs",
    'Config::acl_syntax_error'      =>    "Erro de sntaxe na ACL ",
    'Interfaces::not_configured'    =>    "Dispositivo no encontrado: ",
    'Interfaces::oops_dynamic'      =>    "Dispositivo P2P mas ip_dynaddr desligado: ",
    'Firewall::chdir_core'          =>    "Impossvel entrar no diretrio de ncleo: ",
    'Firewall::chdir_addons'        =>    "Impossvel entrar no diretrio de mdulos: ",
    'Firewall::open_dir'            =>    "Impossvel acessar diretrio: ",
    'Firewall::load_addon'          =>    "Impossvel acessar mdulo: ",
    'Control::restore'              =>    "Erro do iptables(Bug do Alfandega?): ",
    'Control::status::table'        =>    "Tabela: ",
    'Control::status::conntrack'    =>    "Status das linhas de conexo:\n",
    'Control::status::modules'      =>    "Mdulos do kernel carregados:\n",
    'Control::status::modbanner'    =>    "Mdulo              Mdulos Associados\n",
    'Control::status::policy'       =>    "poltica",
    'Control::status::packets'      =>    "pacotes",
    'Control::status::pkts'         =>    "pcts",
    'Control::status::target'       =>    "alvo",
    'Control::status::in'           =>    "ent",
    'Control::status::out'          =>    "sa",
    'Control::status::source'       =>    "origem",
    'Control::status::destination'  =>    "destino",
    'Control::status::opt'          =>    "opc",
    'Control::status::references'   =>    "referncias",
    'Services::syntax_error'        =>    "Erro de Sintaxe na configurao dos servios\n",
    'Services::invalid_acl_name'    =>    "Erro de na configurao dos servios: ACL invlida\n",
);

sub locale {
    my $str = shift;
    return $StrTable{$str};
}

__END__
