# ==============================================================================
# Alfandega::Language::English.pm
# ------------------------------------------------------------------------------
# Copyright(c) 2002 Christian Tosta <c_tosta@yahoo.com.br>. All rights reserved.
# This program is free software; you can redistribute it and/or modify it under
# the same terms as Perl itself.
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
#
#                       Netfilter Language Class: English
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

package Alfandega::Language::English;

require 5.004;
require Exporter;

use strict;
use vars qw(@ISA @EXPORT $VERSION);

@ISA = ('Exporter');
@EXPORT = qw(locale);
$VERSION = "1.3";

my %StrTable = (
    'Language'                      =>    "English",
    'Config::not_specified'         =>    "You must specify the value of ",
    'Config::bad_cfg_version'       =>    "Bad config file version",
    'Config::chdir_basedir'         =>    "Can't chdir to directory: ",
    'Config::opendir'               =>    "Can't access directory: ",
    'Config::acl_file'              =>    "Can't open acl config file: ",
    'Config::bad_acl_version'       =>    "Invalid ACL file version",
    'Config::acl_syntax_error'      =>    "Syntax error on ACL ",
    'Interfaces::not_configured'    =>    "Device not found: ",
    'Interfaces::oops_dynamic'      =>    "P2P device but ip_dynaddr set to 'off'",
    'Firewall::chdir_core'          =>    "Can't chdir to core directory: ",
    'Firewall::chdir_addons'        =>    "Can't chdir to addons directory: ",
    'Firewall::open_dir'            =>    "Can't access directory: ",
    'Firewall::load_addon'          =>    "Can't load addon file: ",
    'Control::restore'              =>    "Iptables error(Alfandega Bug?): ",
    'Control::status::table'        =>    "Table: ",
    'Control::status::conntrack'    =>    "Connection tracking status:\n",
    'Control::status::modules'      =>    "Loaded kernel modules:\n",
    'Control::status::modbanner'    =>    "Module              Referring modules\n",
    'Control::status::policy'       =>    "policy",
    'Control::status::packets'      =>    "packets",
    'Control::status::pkts'         =>    "pkts",
    'Control::status::target'       =>    "target",
    'Control::status::in'           =>    "in",
    'Control::status::out'          =>    "out",
    'Control::status::source'       =>    "source",
    'Control::status::destination'  =>    "destination",
    'Control::status::opt'          =>    "opt",
    'Control::status::references'   =>    "references",
    'Services::syntax_error'        =>    "Syntax Error in services configuration\n",
    'Services::invalid_acl_name'    =>    "Error in services configuration: invalid ACL\n",
);

sub locale {
    my $str = shift;
    return $StrTable{$str};
}

__END__
