# ==============================================================================
# Alfandega::Language::Italian.pm
# ------------------------------------------------------------------------------
# Copyright(c) 2002 Christian Tosta <c_tosta@yahoo.com.br>. All rights reserved.
# This program is free software; you can redistribute it and/or modify it under
# the same terms as Perl itself.
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
#
#                      Netfilter Language Class: Italian
#
# =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

package Alfandega::Language::Italian;

require 5.004;
require Exporter;

use strict;
use vars qw(@ISA @EXPORT $VERSION);

@ISA = ('Exporter');
@EXPORT = qw(locale);
$VERSION = "1.3";

my %StrTable = (
    'Language'                      =>    "Italiano",
    'Config::not_specified'         =>    "Tu deve specificare il valore di ",
    'Config::bad_cfg_version'       =>    "Versione scorretta del file di configurazione",
    'Config::chdir_basedir'         =>    "Impossbile entrare nella directory: ",
    'Config::opendir'               =>    "Impossbile aprire la directory: ",
    'Config::acl_file'              =>    "Impossbile aprire il file di ACLs: ",
    'Config::bad_acl_version'       =>    "Versione invlida del file di ACLs",
    'Config::acl_syntax_error'      =>    "Errore di sintassi nella ACL ",
    'Interfaces::not_configured'    =>    "Dispositivo non trovato: ",
    'Interfaces::oops_dynamic'      =>    "Dispositivo P2P ok, per ip_dynaddr  off: ",
    'Firewall::chdir_core'          =>    "Impossbile entrare nella directory di core: ",
    'Firewall::chdir_addons'        =>    "Impossbile entrare nella directory dei moduli: ",
    'Firewall::open_dir'            =>    "Impossbile aprire la directory: ",
    'Firewall::load_addon'          =>    "Impossbile aprire modulo: ",
    'Control::restore'              =>    "Errore del iptables (Bug nel Alfandega?): ",
    'Control::status::table'        =>    "Tabella: ",
    'Control::status::conntrack'    =>    "Status delle line di connessione:\n",
    'Control::status::modules'      =>    "Moduli del kernel caricati:\n",
    'Control::status::modbanner'    =>    "Modulo              Moduli Associati\n",
    'Control::status::policy'       =>    "politica",
    'Control::status::packets'      =>    "pacchetti",
    'Control::status::pkts'         =>    "pacc",
    'Control::status::target'       =>    "bersaglio",
    'Control::status::in'           =>    "arr",
    'Control::status::out'          =>    "usc",
    'Control::status::source'       =>    "origine",
    'Control::status::destination'  =>    "destinazione",
    'Control::status::opt'          =>    "opt",
    'Control::status::references'   =>    "riferimenti",
    'Services::syntax_error'        =>    "Errore di Sintassi nella configurazione dei servzi\n",
    'Services::invalid_acl_name'    =>    "Errore nella configurazione dei servzi: ACL invlida\n",
);

sub locale {
    my $str = shift;
    return $StrTable{$str};
}

__END__
